'use strict';

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _cssModulesLoaderCore = require('css-modules-loader-core');

var _cssModulesLoaderCore2 = _interopRequireDefault(_cssModulesLoaderCore);

var _parser = require('css-modules-loader-core/lib/parser');

var _parser2 = _interopRequireDefault(_parser);

var _fileSystemLoader = require('css-modules-loader-core/lib/file-system-loader');

var _fileSystemLoader2 = _interopRequireDefault(_fileSystemLoader);

var _generateScopedName = require('./generateScopedName');

var _generateScopedName2 = _interopRequireDefault(_generateScopedName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = _postcss2.default.plugin('postcss-modules', function () {
  var opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  _cssModulesLoaderCore2.default.scope.generateScopedName = opts.generateScopedName || _generateScopedName2.default;

  var loader = new _fileSystemLoader2.default('/', _cssModulesLoaderCore2.default.defaultPlugins);
  var parser = new _parser2.default(loader.fetch.bind(loader));
  var plugins = [_cssModulesLoaderCore2.default.values, _cssModulesLoaderCore2.default.localByDefault, _cssModulesLoaderCore2.default.extractImports, _cssModulesLoaderCore2.default.scope, parser.plugin];

  return function (css) {
    var promise = new Promise(function (resolve) {
      (0, _postcss2.default)(plugins).process(css, { from: css.source.input.file }).then(function () {
        Object.keys(loader.sources).forEach(function (key) {
          css.prepend(loader.sources[key]);
        });

        if (opts.getJSON) {
          opts.getJSON(css.source.input.file, parser.exportTokens);
        }

        resolve();
      });
    });

    return promise;
  };
});